/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Offlineセットアップクラス
//			変更履歴
//				2004.01.08	新規作成	滝島　英幸
//

package jp.co.ntt.lms.lo.Offline;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.util.FileControl;
import jp.co.ntt.lms.xmo.util.DebugLog;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.XMODate;

import java.util.Date;
import java.util.Hashtable;
import java.util.Vector;
import java.io.File;

/**
 * セットアップインタフェースクラス
 *
 * <PRE>
 *   OfflineLoの編集(登録・更新・削除・ユーザ登録・ユーザ削除)をする。
 *   上位にセットアップインタフェースクラスを持つ。
 * </PRE>
 *
 */
public class OfflineSetup extends Setup
	implements OfflineLoPropertyDef
{
	// エラーメッセージ定義
	private final static String NoExitMsg = "レコードがありません";

	////////////////////////////////////////////////////////////////////////////
	// 抽象メソッドの実装
	////////////////////////////////////////////////////////////////////////////
	/**
	 * セットアップ登録処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupInsert(Hashtable htbParam)
			throws LOException
	{
		OfflineLoDataAccess objDataAccess = new OfflineLoDataAccess();

		objDataAccess.insert( htbParam );

		// 教材Tempフォルダから教材フォルダへ教材構造ファイルをコピーする
		OfflineLoEnv objEnv = new OfflineLoEnv();

		// 各パラメータ取得
		String strTempMaterialPath = objEnv.getTempMaterialPath();
		String strMaterialPath     = objEnv.getMaterialPath();
		String strMaterialID       = (String)htbParam.get(MATERIALID);

		// コピー元ファイルパス作成
		strTempMaterialPath = strTempMaterialPath + "/" +
							  strMaterialID + "/" +
							  strMaterialID + ".xml";
		// コピー先ファイルパス作成
		strMaterialPath     = strMaterialPath + "/" +
							  strMaterialID + "/" +
							  strMaterialID + ".xml";
		DebugLog.write(this.getClass(), "TempDir : [" + strTempMaterialPath + "]", DebugLog.ROW);
		DebugLog.write(this.getClass(), "MatDir  : [" + strMaterialPath + "]", DebugLog.ROW);

		if( htbParam.get( COPY_FLAG ) == null ) {
			// LOレコードコピーフラグが設定されていない場合は構造構造をコピーする
			// コピー処理
			try
			{
				FileControl objFc = new FileControl();
				objFc.copy(strTempMaterialPath, strMaterialPath);
				// コピーが成功した場合Temp教材xmlは削除する
				File objFile      = new File(strTempMaterialPath);
				if(!objFile.delete())
				{
					DebugLog.write(this.getClass(), "教材構造ファイルの削除に失敗しました。", DebugLog.HIGHT);
				}
				// 教材構造を読み込みパースします。
				OfflineMaterialConverter.convert( strMaterialPath );
			}
			catch(Exception e)
			{
				throw new LOException("教材構造ファイルのコピーに失敗しました。");
			}
		}
	}

	/**
	 * セットアップ更新処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupUpdate(Hashtable htbParam)
			throws LOException
	{
		OfflineLoDataAccess objDataAccess = new OfflineLoDataAccess();

		objDataAccess.update( htbParam );
	}

	/**
	 * セットアップ削除処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupDelete(Hashtable htbParam)
			throws LOException
	{
		OfflineLoDataAccess objDataAccess = new OfflineLoDataAccess();
		try {
			//MaterialIDをデータベースから取得
			String strMaterialID = objDataAccess.getMaterialID( htbParam );
			if ( strMaterialID == null ) {
				throw new LOException( NoExitMsg );
			}
			OfflineLoEnv objEnv = new OfflineLoEnv();
			// 教材格納フォルダパスの組み立て
			String strMaterialPath = objEnv.getMaterialPath() + "/" + strMaterialID;
			FileControl objFc = new FileControl();
			//フォルダ消去
			objFc.delete(strMaterialPath);
		} catch (Exception e){
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException( e.getMessage() );
		}
		objDataAccess.delete( htbParam );

	}

	/**
	 * セットアップユーザ登録処理
	 *
	 * @param htbParam パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupAddUser(Hashtable htbParam)
		throws LOException
	{
		// Offline教材は処理なし
	}


	/**
	 * セットアップユーザ削除処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected void setupDelUser(Hashtable htbParam)
		throws LOException
	{
		// Offline教材は処理なし
	}


	/**
	 * セットアップコピー処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected void setupCopy(Hashtable htbParam)
		throws LOException
	{

	}


	/**
	 * 安全にHashtableに追加するメソッドです
	 */
	private void putData( Hashtable htbData, String strValue, String strKey ) {
		if( strKey != null ) {
			htbData.put( strKey, strValue );
		}
	}


}

